﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.Charting;
using Telerik.WinControls.UI;

namespace _967078_RadChartViewImageExporting
{
    public partial class Form1 : Form
    {
        private StatisticLayoutWithAdditionalStats myUserControl;

        public Form1()
        {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this.myUserControl = new StatisticLayoutWithAdditionalStats();
            this.myUserControl.ChartView.ChartElement.LegendElement.VisualItemCreating += LegendElement_VisualItemCreating;
            this.myUserControl.Title = "Blablabla";
            this.myUserControl.ChartView.AreaType = ChartAreaType.Cartesian;
            this.myUserControl.ChartView.ShowLegend = true;

            LineSeries lineSeries = new LineSeries();
            lineSeries.Name = "Series1";
            lineSeries.DataPoints.Add(new CategoricalDataPoint(20, "Jan"));
            lineSeries.DataPoints.Add(new CategoricalDataPoint(22, "Apr"));
            lineSeries.DataPoints.Add(new CategoricalDataPoint(12, "Jul"));
            lineSeries.DataPoints.Add(new CategoricalDataPoint(19, "Oct"));
            this.myUserControl.ChartView.Series.Add(lineSeries);

            LineSeries lineSeries2 = new LineSeries();
            lineSeries2.Name = "Series2";
            lineSeries2.DataPoints.Add(new CategoricalDataPoint(18, "Jan"));
            lineSeries2.DataPoints.Add(new CategoricalDataPoint(15, "Apr"));
            lineSeries2.DataPoints.Add(new CategoricalDataPoint(17, "Jul"));
            lineSeries2.DataPoints.Add(new CategoricalDataPoint(22, "Oct"));
            this.myUserControl.ChartView.Series.Add(lineSeries2);
        }

        private void LegendElement_VisualItemCreating(object sender, Telerik.WinControls.UI.LegendItemElementCreatingEventArgs e)
        {
            e.ItemElement = new CheckBoxLegentItemElement(e.LegendItem);
            if (((LineSeries)e.LegendItem.Element).Name == "Series1")
            {
                ((CheckBoxLegentItemElement)e.ItemElement).CheckBox.Checked = false;
            }
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
            Bitmap bitmap = new Bitmap(this.myUserControl.Size.Width, this.myUserControl.Size.Height);
            this.myUserControl.DrawToBitmap(bitmap, (this.myUserControl.ClientRectangle));
            bitmap.Save(@"..\..\test.png", ImageFormat.Png);
        }
    }

    public class CheckBoxLegentItemElement : LegendItemElement
    {
        private RadCheckBoxElement checkBox = new RadCheckBoxElement();

        public CheckBoxLegentItemElement(LegendItem item)
            : base(item)
        {
            this.checkBox.ToggleStateChanged += checkBox_ToggleStateChanged;
        }

        public RadCheckBoxElement CheckBox
        {
            get { return this.checkBox; }
        }

        protected override void CreateChildElements()
        {
            base.CreateChildElements();
            checkBox.ToggleState = Telerik.WinControls.Enumerations.ToggleState.On;
            this.Children.Add(checkBox);
            checkBox.ToggleStateChanged += checkBox_ToggleStateChanged;
        }

        void checkBox_ToggleStateChanged(object sender, StateChangedEventArgs args)
        {
            if (args.ToggleState == Telerik.WinControls.Enumerations.ToggleState.On)
            {
                this.LegendItem.Element.IsVisible = true;
            }
            else
            {
                this.LegendItem.Element.IsVisible = false;
            }
        }
    }
}
